<?php
	/**
	 model类 数据库处理类
	*/
	class DBModel{
		private $tabName = null; //数据表名
		private $link = null; //数据库连接资源
		private $pk = null; //该表的主键
		private $fields = array(); //包含表中的字段
		private $where = array(); //保存搜索条件
		private $order = null; //保存排序条件
		private $limit = null; //分页条件
		private $fieldList = null;  //要查询的字段
		
		/**
		 * 构造方法  用于打开数据库资源
		 * @param string $tabName 表名
		*/
		public function __construct($tabName,$dbName = MryDb){
			//给属性赋值
			$this->tabName = $tabName;
			//打开数据库资源
			$this->link = mysql_connect(MryHost,MryUser,MryPass)or die('数据库连接失败');
			//选择数据库
			mysql_select_db($dbName);
			//设置编码
			mysql_set_charset('utf8');
			//自动获取字段
			$this->getField();			
		}
		
		
		/**
		 * 查询数据库中所有的数据
		*/
		public function select(){
		
			//var_dump($this->where);
			
			//判断有没有指定字段
			if(!empty($this->fieldList)){
					//定义sql语句
				$sql = "select {$this->fieldList} from {$this->tabName}";
			}else{
				//定义sql语句
				$sql = "select * from {$this->tabName}";
			}
		
			
			
			//判断是否有搜索条件
			if(!empty($this->where)){
				//拼装sql
				$sql .= " where ".implode(" and ",$this->where);
				//销毁先的搜索条件
				$this->where = array();
			}
			
			//是否有 排序条件
			if(!empty($this->order)){
				$sql .= " order by ".$this->order;
				//清除原先的排序条件
				$this->order = null;
			}
			
			//判断是否有分页条件
			if(!empty($this->limit)){
				$sql .= " limit ".$this->limit;
				//清除原先的排序条件
				$this->limit = null;
			}
			
			//echo $sql;
			//发送sql语句 返回结果集
			$result = mysql_query($sql,$this->link);
			//处理结果集
			$data = array();  //定义空数组
			//将返回的结果集放到数组里
			if ($result==""||$result==null){
				return 0;
			}else{
				while($rows = mysql_fetch_assoc($result)){
					$data[] = $rows;
				}
				return $data;
			}
		}
		/**
		 * 查询单条数据
		 * @param  string $id  主键的值
		*/
		public function find($id){
			//定义sql语句
			$sql = "select * from {$this->tabName} where {$this->pk}={$id}";
			//发送sql 返回结果集
			$result = mysql_query($sql,$this->link);
			//处理结果集
			return mysql_fetch_assoc($result);
		}
		
		/**
		 * 添加数据
		 * @param  array $data 要插入的数据
		*/
		public function add($data=array()){
			//如果data为空
			if(empty($data)){
				$data = $_POST;
			}
			
			
			$fieldList = array(); //用于存放过滤后的字段集合
			$dataList = array(); //用于存放过滤后的值的集合
			//过滤
			//循环 
			foreach($this->fields as $field){
				
				//如果 data和字段中都有该值
				if(array_key_exists($field,$data)){
					$fieldList[] = $field; //添加字段
					$dataList[] = $data[$field];
				}
			}
			
			//var_dump($fieldList);
			//var_dump($dataList);
			
			
			//定义sql语句
			$sql = "insert into {$this->tabName}(".implode(',',$fieldList).") values('".implode("','",$dataList)."')";
			//echo $sql;
			// 发送sql
			mysql_query($sql,$this->link);
			//返回 自增id
			return mysql_insert_id($this->link);
		}
		
		/**
		 * 修改数据
		 * @param array $data 要修改的数据  
		*/
		public function save($data=array()){
			//如果data没有值
			if(empty($data)){
				$data = $_POST;
			}
			
			$str = ""; //定义空字符串
			//过滤
			foreach($this->fields as $field){
				//判断 字段列表 和 表单都存在对1值
				if(array_key_exists($field,$data)){
					$str .= "$field = '{$data[$field]}',";
				}
			}
			
			//定义sql语句
			$sql = "update {$this->tabName} set ".rtrim($str,',')." where {$this->pk}='{$data[$this->pk]}'";
			
			//发送sql语句
			mysql_query($sql,$this->link);
			
			//返回 影响行数
			return mysql_affected_rows($this->link);
		
		}
		
		
		
		/**
		 * 删除数据
		 * @param string $id 主键
		*/
		public function delete($id){
			//定义sql语句
			$sql = "delete from {$this->tabName} where {$this->pk}={$id}";
			//发送sql
			mysql_query($sql,$this->link);
			//返回影响行数
			return mysql_affected_rows($this->link);
		
		}
		
		
		/**
		 * where 用于添加搜索条件
		 * @param string $where 搜索条件
		*/
		public function where($where){
			$this->where[] = $where;
			return $this;
		}
		
		/**
		 * 排序 order
		 * @param string $order 排序条件
		*/
		public function order($order){
			$this->order = $order;
			return $this;
		}
		
		
		/**
		 * 分页条件 limit
		 * @param string $limit 分页条件
		*/
		public function limit($limit){
			$this->limit = $limit;
			return $this;
		}
		
		/**
		 * 指定要查询的字段
		 * @param string $field 要查询的字段
		*/
		public function field($field){
			$this->fieldList = $field;
			return $this;
		}
		
		/**
		 * query 方法， 自己发送sql语句
		 * @param string $sql  sql语句
		*/
		public function query($sql){
			//发送sql
			$res = mysql_query($sql,$this->link);
			//判断$res 是否是资源
			if(is_resource($res)){
				//查询的sql语句
				//处理结果集
				$data = array();  //定义空数组
				//将返回的结果集放到数组里
				while($rows = mysql_fetch_assoc($res)){
					$data[] = $rows;
				}
				return $data;
			}
			$id = mysql_insert_id($this->link);
			
			//判断是否是插入操作
			if($id>0){
				return $id;
			}
			
			//返回影响行数
			return mysql_affected_rows();
		
		}
		/**
		 * 获取表的主键
		*/
		private function getField(){
			//定义sql语句
			$sql = "desc {$this->tabName}";
			//发送给mysql
			$result = mysql_query($sql,$this->link);
			//处理结果集
			while(@$rows = mysql_fetch_assoc(@$result)){
				//var_dump($rows);
				//判断每条字段的key
				if($rows['Key'] == "PRI"){
					$this->pk = $rows['Field'];
					continue; 
				}
				
				$this->fields[] = $rows['Field'];
			}
			
			//var_dump($this->fields);
		}
		
	}

?>